<script lang="ts">
import Vue from "vue";
import SlpNavigationDesktop from "./navigation-desktop.vue";
import SlpNavigationMobile from "./navigation-mobile.vue";
import { FreeTrialVariant } from "@/common/constants";

const HOMEPAGE_PATHNAMES = [
  "/",
  "/de-de",
  "/de-de/",
  "/es",
  "/es/",
  "/fr-fr",
  "/fr-fr/",
  "/ja-jp",
  "/ja-jp/",
  "/it-it",
  "/it-it/",
  "/pt-br",
  "/pt-br/",
];

export default Vue.extend({
  name: "SlpNavigation",
  components: {
    SlpNavigationMobile,
    SlpNavigationDesktop,
  },
  props: {
    contentfulNavigationData: {
      type: Object,
      required: true,
    },
    freeTrialVariant: {
      type: String,
      default: FreeTrialVariant.PRIMARY,
      validator(value) {
        return Object.values(FreeTrialVariant).includes(
          value as FreeTrialVariant
        );
      },
    },
  },
  data() {
    return {
      hideSalesButton: false,
      freeTrialLink: "",
      navigationData: null,
    };
  },
  beforeMount() {
    this.navigationData = this.formatCtfNavigationData(
      this.contentfulNavigationData
    );
  },
  mounted() {
    this.initNavigationConfig();
  },
  watch: {
    // This is a patch for our broken 404 page in development mode. 
    contentfulNavigationData: {
      handler(newVal, oldVal) {
        this.navigationData = this.formatCtfNavigationData(
          this.contentfulNavigationData
        );
      },
    },
  },
  methods: {
    initNavigationConfig() {
      // Checks if we are in the homepage to hide
      // the secondary CTA "Talk to an expert" from header
      this.hideSalesButton = HOMEPAGE_PATHNAMES.some(
        (pathname) => pathname === window.location.pathname
      );

      // Dynamically adds the source to GLM
      this.freeTrialLink = decodeURIComponent(
        `https://gitlab.com/-/trial_registrations/new?glm_source=${
          window.location.hostname + window.location.pathname
        }&glm_content=default-saas-trial`
      );
    },
    formatCtfNavigationData(ctfData: any) {
      const formattedNav = {
        ...ctfData.fields,
        freeTrial: { ...ctfData.fields.freeTrial.fields },
        login: { ...ctfData.fields.login.fields },
        sales: { ...ctfData.fields.sales.fields },
      };
      formattedNav.navItems = ctfData.fields.navItems.map((item) => {
        let formattedItem = { ...item.fields };

        if (formattedItem.categories) {
          formattedItem = {
            ...formattedItem,
            bottomLink: formattedItem.bottomLink
              ? { ...formattedItem.bottomLink.fields }
              : null,
            primarySideSection: this.formatCtfSideSection(
              formattedItem.primarySideSection
            ),
            secondarySideSection: this.formatCtfSideSection(
              formattedItem.secondarySideSection
            ),
            categories: this.formatCtfCategories(formattedItem.categories),
          };
        }

        return formattedItem;
      });

      return formattedNav;
    },
    formatCtfSideSection(sideSection: any) {
      let formattedSideSection = null;

      if (sideSection) {
        formattedSideSection = {
          ...sideSection.fields,
          primaryLink: sideSection.fields.primaryLink
            ? { ...sideSection.fields.primaryLink.fields }
            : null,
          secondaryLink: sideSection.fields.secondaryLink
            ? { ...sideSection.fields.secondaryLink.fields }
            : null,
        };

        if (sideSection.fields.image) {
          formattedSideSection.image = {
            altText: sideSection.fields.image.fields.altText,
            url: sideSection.fields.image.fields.image.fields.file.url,
          };
        }
      }

      return formattedSideSection;
    },
    formatCtfCategories(categories: any[]) {
      return categories.map((category) => ({
        ...category.fields,
        items: (category.fields.items || []).map((item) => item.fields),
      }));
    },
  },
});
</script>

<template>
  <nav
    v-if="navigationData"
    id="navigation"
    role="menu"
    aria-labelledby="mainmenulabel"
  >
    <slp-navigation-desktop
      id="be-navigation-desktop"
      class="be-nav-navigation-desktop"
      :data="navigationData"
      :free-trial-link="freeTrialLink"
      :free-trial-variant="freeTrialVariant"
      :hide-sales-button="hideSalesButton"
    />
    <slp-navigation-mobile
      id="be-navigation-mobile"
      class="be-nav-navigation-mobile"
      :navigation-data="navigationData"
      :free-trial-link="freeTrialLink"
      :hide-sales-button="hideSalesButton"
    />
  </nav>
</template>

<style lang="scss">
:lang(en) {
  .be-nav-navigation-mobile {
    @media (max-width: $breakpoint-lg) {
      display: block;
    }
  }
  .be-nav-navigation-desktop {
    @media (min-width: ($breakpoint-lg + 1)) {
      display: block;
    }
  }
}

:not(:lang(en)) {
  .be-nav-navigation-mobile {
    @media (max-width: $breakpoint-xl) {
      display: block;
    }
  }
  .be-nav-navigation-desktop {
    @media (min-width: ($breakpoint-xl + 1)) {
      display: block;
    }
  }
}

#navigation {
  position: sticky;
  left: 0;
  right: 0;
  top: 0;
  z-index: 1025;
}
.be-nav-navigation-mobile {
  display: none;
  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  border: none;
}

.be-nav-navigation-desktop {
  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  display: none;
}
</style>
